<?php

class Model_Helper_RecordBookBuilder extends Model_Helper_Builder
{
    public function create() {
        $required = [
            'StudentID', 'PlanID', 'SemesterID',
        ];
        echo Debug::vars($this->data);
        if (array_diff($required, array_keys($this->data)))
            throw new InvalidArgumentException('Not enough arguments');

        return new Model_RecordBook($this->data, false);
    }

    public function & studentID($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('student id is incorrect');
        $this->data['StudentID'] = (int) $id;
        return $this;
    }

    public function & planID($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('plan id is incorrect');
        $this->data['PlanID'] = (int) $id;
        return $this;
    }

    public function & facultyID($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('Faculty id is incorrect');
        $this->data['FacultyID'] = (int) $id;
        return $this;
    }

    public function & semesterID($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('Semester id is incorrect');
        $this->data['SemesterID'] = (int) $id;
        return $this;
    }

    public function & grade($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('Grade is incorrect');
        $this->data['Grade'] = (int) $id;
        return $this;
    }

    public function & group($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('Group is incorrect');
        $this->data['Group'] = (int) $id;
        return $this;
    }

    public function & externalID($id) {
        $id = trim($id);

        $this->data['ExternalID'] = $id;
        return $this;
    }
}
